#ifndef TDE_WIDGETS_CHECKBOX_H
#define TDE_WIDGETS_CHECKBOX_H

#include <QWidget>
#include <QCheckBox>

#include "common.h"
#include "opaque.h"

// -- TDE NAMESPACE ----------------------------------------------------

namespace TDE {

// -- Widgets NAMESPACE ------------------------------------------------

namespace Widgets {

/*!
 * \class CheckBox
 * \brief Widget for editing boolean Engine variables through check boxes.
 *
 * \see TDE::DataStore
 * \see WidgetInfo
 */
class CheckBox : public QCheckBox
{
    Q_OBJECT
	Q_PROPERTY(QString variableName READ variableName WRITE setVariableName NOTIFY variableChanged)
    Q_PROPERTY(bool trace READ trace WRITE setTrace NOTIFY traceChanged)
    Q_PROPERTY(int refresh READ refresh WRITE setRefresh NOTIFY refreshChanged)
    Q_PROPERTY(bool descriptionAppend READ descriptionAppend WRITE setDescriptionAppend)
    Q_PROPERTY(bool descriptionPrepend READ descriptionPrepend WRITE setDescriptionPrepend)

public:
    CheckBox(QWidget *parent = 0);
    virtual ~CheckBox();

    SHARED_PTR<TDE::DataStore> dataStore();
    CheckBox& setDataStore(SHARED_PTR<TDE::DataStore> ds_p);
    CheckBox& setVariableName(const std::string& name);

    int     variableIndex() const;
    const TDE::VariableDescr& variableDescr() const;

    // properties getters/setters

    QString variableName() const;
    void    setVariableName(const QString&);

    bool trace() const;
    bool setTrace(bool value = true);

    int refresh() const;
    int setRefresh(int value = 0);

    bool setDescriptionAppend(bool value = true);
    bool descriptionAppend() const;
    bool setDescriptionPrepend(bool value = true);
    bool descriptionPrepend() const;

signals:
    void variableChanged(QString);

    void traceChanged(bool);                // trace option changed
    void refreshChanged(int);               // refresh value changed
    void ui2LoggerMsg(QString);

public slots:
    void contentsEdited(bool state);

    void ui2ds();    // set DataStore variable with value from UI
    void ds2ui();    // set UI with value from DataStore
    void showTooltip();   //show Tooltip delayed

private:
	SHARED_PTR<WidgetInfo> m_winfo;
    QString dbStr;
    QString originalTip;

protected:
    virtual void showEvent(QShowEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent* e);
};

} /* end of namespace Widgets */

} /* end of namespace TDE */

#endif /* TDE_WIDGETS_CHECKBOX_H */
